package com.winhc.bigdata.spark.ng.chance_v9.table

import com.winhc.bigdata.spark.implicits.MapHelper._
import com.winhc.bigdata.spark.ng.chance_v9.{ChangeExtract, CompanyChanceRecord, CompanyChanceUtils}
import com.winhc.bigdata.spark.ng.chance_v9.CompanyChanceHandleV9
import com.winhc.bigdata.spark.utils.DateUtils

/**
 * @Date: 2021/9/29
 * @Description:购地信息
 */
case class company_land_announcement(is_inc: Boolean) extends CompanyChanceHandleV9 {
  override def getBizDate(newMap: Map[String, String]): String =  DateUtils.getBizDate(newMap("contract_date"))

  override def get_conditional_filter(): String = {
    ""
  }

  override def filter: (String, String, Seq[String], Map[String, String], Map[String, String]) => Boolean = (update_type: String, biz_date: String, change_fields: Seq[String], old_data: Map[String, String], new_data: Map[String, String]) => {
    if (CompanyChanceUtils.default_filter(update_type, biz_date, change_fields, old_data, new_data)) {
      if (update_type.equals("insert")) true
      else
        false
    } else {
      false
    }
  }

  override def getCompanyIds(new_data: Map[String, String]): Seq[String] = {
    Seq(new_data.getOrEmptyStr("company_id"))
  }

  override def flat_map: ChangeExtract => Seq[CompanyChanceRecord] = (change_extract: ChangeExtract) => {
    getCompanyChanceRecord(change_extract, getCompanyIds(change_extract.new_data))
  }
}
